// Condition.cpp: implementation of the CCondition class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCondition::CCondition()
{

}

CCondition::~CCondition()
{
}

bool CCondition::set_XML( IXMLDOMNodePtr e )
{
	_variant_t v;

	e->attributes->getNamedItem( "variable" )->get_nodeValue( &v );
	variable = _bstr_t(v);

	e->attributes->getNamedItem( "operator" )->get_nodeValue( &v );
	oper = _bstr_t(v);

	e->attributes->getNamedItem( "value" )->get_nodeValue( &v );
	value = _bstr_t(v);

	return true;
}

bool CCondition::evaluate(CQuery &query)
{
	string rvalue = query.getValue( variable );

#ifdef DEBUG
	cout << "\t" << variable << "(" << rvalue << ")" << oper << value << endl;
#endif

	if ( oper == ">"  && rvalue > value )
		return true;
	if ( oper == ">=" && rvalue >= value )
		return true;
	if ( oper == "==" && rvalue == value )
		return true;
	if ( oper == "<=" && rvalue <= value )
		return true;
	if ( oper == "<"  && rvalue < value )
		return true;
	if ( oper == "!=" && rvalue != value )
		return true;

	return false;
}
