#ifndef TODOCLASSES_H
#define TODOCLASSES_H

#define SP_SEND_STEP              150
#define TIME_TO_DELIBERATE         80
#define TIME_TO_SEND               50

enum EEventType  {
    ET__NONE = 0,
    ET__RECEIVED_MSG,
    ET__START_DELIBERATION,
    ET__SEND_COMMANDS
};

class CEvent {
public:
    EEventType m_eType;

public:
    CEvent(EEventType eType = ET__NONE) { m_eType = eType; };
};

class CStartDeliberationEvent : public CEvent {
public:
    CGameTime m_cGameTime;
    CPerceptionSeq *m_pPerceptionSeq;
    CGameCommandSeq *m_pGameCommandSeq;

    CStartDeliberationEvent() : CEvent(ET__START_DELIBERATION) {};
};

class CSendDataEvent : public CEvent {
public:
    CGameCommandSeq *m_pGameCommandSeq;

    CSendDataEvent() : CEvent(ET__SEND_COMMANDS) {};
};


//! t0n0
//extern FILE *m_ff;
//extern CTextMessageBuffer foo;

//! t0n0
class CChildView;
class CChildTextView;
extern CChildView *m_pReadyView;
extern CChildTextView* m_pTextReadyView;

#endif  // TODOCLASSES_H
