// ParameterQuery.cpp: implementation of the CParameterQuery class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CParameterQuery::CParameterQuery(CLocalAgent *pAgent) : CQuery()
{
	addTerm( new CBestLocatedTeamMateTerm(pAgent) );
	addTerm( new CFreePositionTerm(pAgent) );
	addTerm( new CBestLocationForPassTerm(pAgent) );
	addTerm( new CActionPositionTerm(pAgent) );
	addTerm( new CStrategicPositionTerm(pAgent) );
	addTerm( new CBallInterceptPositionTerm(pAgent) );
	addTerm( new CBallPositionTerm(pAgent) );
	addTerm( new CGoalTerm(pAgent) );
}

string CBestLocatedTeamMateTerm::Evaluate()
{
	return "1";
}

string CFreePositionTerm::Evaluate()
{
	return "0.0 0.0";
}

string CBestLocationForPassTerm::Evaluate()
{
	return "0.0 0.0";
}

string CActionPositionTerm::Evaluate()
{
	C2DVector& v = m_pAgent->field->GetGoal(GT_OPPONENT);
	string tmps;
	char buf[100];
	sprintf( buf, "%lf %lf", (v.GetX() - 15.0), v.GetY() );
	tmps = buf;

	return tmps;
}

string CStrategicPositionTerm::Evaluate()
{
	C2DVector& v = m_pAgent->field->GetGoal(GT_OPPONENT);
	string tmps;
	char buf[100];
	sprintf( buf, "%lf %lf", (v.GetX() - 15.0), v.GetY() );
	tmps = buf;

	return tmps;
}

string CBallInterceptPositionTerm::Evaluate()
{
	return "0.0 0.0";
}

 // Rado Otipka 16. 12. 2001 11:09:09
string CBallPositionTerm::Evaluate()
{
	C2DVector v = m_pAgent->GetWorldModel()->GetBall()->GetPosition();
	string tmps;
	char buf[100];
	sprintf( buf, "%lf %lf", v.GetX(), v.GetY() );
	tmps = buf;
	return tmps;
}

string CGoalTerm::Evaluate()
{
	C2DVector& v = m_pAgent->field->GetGoal(GT_OPPONENT);
	string tmps;
	char buf[100];
	sprintf( buf, "%lf %lf", v.GetX(), v.GetY() );
	tmps = buf;

	return tmps;
}
